.586
.MODEL FLAT,STDCALL
OPTION CASEMAP:NONE

INCLUDE windows.inc

INCLUDE kernel32.inc
INCLUDE user32.inc
INCLUDE msvcrt.inc
INCLUDE masm32.inc

INCLUDE c:\masm32\macros\macros.asm

INCLUDELIB kernel32.lib
INCLUDELIB user32.lib
INCLUDELIB msvcrt.lib
INCLUDELIB masm32.lib

main PROTO
ShowBytes PROTO pqwBytes:PTR QWORD

.DATA

    ALIGN 8
    ; Maximum signed QWORD (7FFFFFFFFFFFFFFFh) = 8 exbibytes
    ;qwBytes QWORD 0
    ;qwBytes QWORD 123                 ; 123 bytes
    ;qwBytes QWORD 1536                ; 1.5 kB
    ;qwBytes QWORD 21915238            ; 20.9 MB
    ;qwBytes QWORD 21474836480         ; 2 GB
    qwBytes QWORD 1649267441664       ; 1.5 TB
    ;qwBytes QWORD 230809480902737920  ; 205 PB
    ;qwBytes QWORD 7FFFFFFFFFFFFFFFh   ; 8 EB

.CODE

start:

    call main
    inkey SADD(13,10,"Press any key to exit ... ")
    INVOKE ExitProcess, eax

main PROC

    finit
    INVOKE ShowBytes, ADDR qwBytes
    INVOKE StdOut, chr$(13,10)

    ret
main ENDP

ShowBytes PROC pqwBytes:PTR QWORD
    LOCAL tmpReal8:REAL8
    .DATA
        ALIGN 8
        mult_table   REAL8 1.0
                     REAL8 0.0009765625          ; 1/1KB
                     REAL8 9.5367431640625E-07   ; 1/1MB
                     REAL8 9.31322574615479E-10  ; 1/1GB
                     REAL8 9.09494701772928E-13  ; 1/1TB
                     REAL8 8.88178419700125E-16  ; 1/1PB
                     REAL8 8.67361737988404E-19  ; 1/1EB
        string_table BYTE "bytes",0,0,0
                     BYTE "kB",0,0,0,0,0,0
                     BYTE "MB",0,0,0,0,0,0
                     BYTE "GB",0,0,0,0,0,0
                     BYTE "TB",0,0,0,0,0,0
                     BYTE "PB",0,0,0,0,0,0
                     BYTE "EB",0,0,0,0,0,0
    .CODE
        ;put a finit somewhere
        mov edx, pqwBytes
        fild QWORD PTR [edx]
        bsr eax, [edx+4]
        jz lodword
        add eax, 32
        jmp gothibit
      lodword:
        xor eax, eax    ;if the register is 0, BSR won't correctly update the register
        bsr eax, [edx]
        jz done         ;it's zero
      gothibit:
        mov ecx, 10     ;divide high bit position by 10
        xor edx, edx
        div ecx         ;eax is now the index into the tables
        lea edx, [mult_table+eax*8]
        fmul REAL8 PTR [edx]
      done:
        fstp tmpReal8
        lea edx, [string_table+eax*8]
        INVOKE crt_printf, SADD("%.2f %s"), tmpReal8, edx
        ret
ShowBytes ENDP

END start

